setenv TZ "GMT"

set yr = `date +%Y`
set yy = `date +%y`
set dy = `date +%d`
set dz = `date +%j`
set mn = `date +%m`

#--- Manually set date info
#set dy = 08    
#set dz = 008

echo $yr,  4-digit year
echo $yy,  2-digit year
echo $dy,  day of the month
echo $dz,  julian day
echo $mn,  2-digit number of month

cd $DATA

set iyy = ${yy}
set iyr = ${yr}
set imn = ${mn}
set idy = ${dy}

set ayr = 00
set amn = 00
set ady = 00

set ckfiles = 0  #indicator of what files are available (i.e., 25km, 4km, both)
set yrck = 0     #checks if 2-digit year is 99

set endday = 7  #looks back 7 days for old 25km SSM/I data in case current data not available
set i = 0
while ( ${i} <= ${endday})

#deal with octal issue by removing 0's from in front
set dz = `echo ${dz} | sed 's/^0//'`
set dz = `echo ${dz} | sed 's/^0//'`
set idy = `echo ${idy} | sed 's/^0//'`
set imn = `echo ${imn} | sed 's/^0//'`
set iyy = `echo ${iyy} | sed 's/^0//'`

#set ckfiles = 0
if (${i} > 0) then
 # subtract date by ${i} days
 if (${idy} == 1) then
  if (${imn} == 1) then
   @ iyy --
   @ iyr --
   set imn = 12
   if (${iyy} == 0) set yrck = 1
  else
   @ imn --
  endif
  if (${imn} == 1 || ${imn} == 3 || ${imn} == 5 || ${imn} == 7 || ${imn} == 8 || ${imn} == 10 || ${imn} == 12) set idy = 31
  if (${imn} == 4 || ${imn} == 6 || ${imn} == 9 || ${imn} == 11) set idy = 30
  if (${imn} == 2) set idy = 29
 else
  @ idy --
 endif
endif

# put '0' back in front for naming purposes
if (${imn} < 10) set imn = 0${imn}
if (${idy} < 10) set idy = 0${idy}
if (${dz} < 10) then
  set dz = 00${dz}
else if (${dz} >= 10 && ${dz} < 100) then
  set dz = 0${dz}
endif
if (${iyy} < 10) set iyy = 0${iyy}
if (${yrck} == 1) then
 set iyy = 99
 set yrck = 0
endif
#echo ${iyr}, ${imn}, ${idy}

############################################################
#  Grab 25km SSM/I global ice concen. and snow extent data
############################################################
if ( ${ckfiles} == 0 ) then
echo check for $DATA/NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS
if (! -e $DATA/NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS) then
echo $DATA/NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS does not exist, download it

##ftp -v n0dps01u.ecs.nasa.gov << XXX    #must have changed servers around March 08
##ftp -v n4ftl01u.ecs.nasa.gov << XXX    # new server change January 2014
#ftp -v n5eil01u.ecs.nsidc.org << XXX
#
#passive
#binary
#cd /SAN/OTHR/NISE.004/${iyr}.${imn}.${idy}
#get NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS
#
#bye
#XXX

# Grab MW data from HTTPS server
wget --load-cookies ~/.urs_cookies --save-cookies ~/.urs_cookies --keep-session-cookies --no-check-certificate --auth-no-challenge=on -r --reject "index.html*" -nd -np https://n5eil01u.ecs.nsidc.org/OTHR/NISE.005/${iyr}.${imn}.${idy}/NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS

endif
endif

if ( -e $DATA/NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS ) then
 if ( ${ckfiles} == 0 ) then

  set ayr = ${iyr}
  set amn = ${imn}
  set ady = ${idy}

  if ( ${i} == 0) then
   echo current 25km data avail: NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS
   set ckfiles = 2
  else 
   echo current 25km data NOT available
  endif

  if (${i} > 0) then
   echo 'date of latest SSM/I file is:' ${ayr}, ${amn}, ${ady}
   echo previous 25km data avail: NISE_SSMISF18_${iyr}${imn}${idy}.HDFEOS
   set ckfiles = 1
  endif

 endif
endif

if (${i} == ${endday} && ${ckfiles} == 0) echo 'no older 25km SSM/I data available if no current data'
@ i ++
end

############################################################
#  Grab 4km northern hemisphere IMS data
############################################################
set i = 1
while ( ${i} <= 3)

echo check for $DATA/ims${yr}${dz}_4km_v1.3.asc
if (! -e $DATA/ims${yr}${dz}_4km_v1.3.asc) then

ftp -v sidads.colorado.edu << XXX

passive
binary
cd /pub/DATASETS/NOAA/G02156/4km/${yr}
get ims${yr}${dz}_4km_v1.3.asc.gz

bye
XXX

endif

#Unzip 4km ims snow file
gunzip $DATA/ims${yr}${dz}_4km_v1.3.asc.gz

if ( -e $DATA/ims${yr}${dz}_4km_v1.3.asc) then
 echo current 4km data avail: ims${yr}${dz}_4km_v1.3.asc
 if (${ckfiles} == 1) set ckfiles = 3
 if (${ckfiles} == 2) set ckfiles = 4
 break
endif

#deal with octal issue by removing 0's from in front
set dz = `echo ${dz} | sed 's/^0//'`
set dz = `echo ${dz} | sed 's/^0//'`
set yy = `echo ${yy} | sed 's/^0//'`

if (${dz} > 1) then
 @ dz --
 if (${dz} < 10) set dz = 00${dz}
 if (${dz} >= 10 && ${dz}<100) set dz = 0${dz}
 @ i ++
else
 @ yr --
 @ yy --
 if (${yr} == 1999 || ${yr} == 2099) set yy = 99
 set dz = 366
 set i = 1
endif
if ( -e $CODE/julian2mthdy.input) rm $CODE/julian2mthdy.input
cat <<EOF>> $CODE/julian2mthdy.input
${yr}
${dz}
EOF
set dy = `$CODE/julian2dy_pro < $CODE/julian2mthdy.input`
#Put '0' back in front of single digit mth/dy numbers
if ( ${dy} < 10 ) set dy = 0${dy}

end

############################################################
# Create proper input file to feed file names and run 
#   the program snow_ice.f90 to merge snow/ice data
#   products onto equal angle grid.
############################################################
cd $CODE

if ( -e $CODE/snow_ice.input ) rm $CODE/snow_ice.input

echo ckfiles = ${ckfiles}

if (${ckfiles} == 2) then
cat <<EOF>> $CODE/snow_ice.input
${ckfiles}  !indicates what snow/ice products are available: 0=none,1=old25km,2=new25km,3=new4km,4=bothnew
$CODE/
$DATA/
NISE_SSMISF18_${ayr}${amn}${ady}.HDFEOS
EOF
endif

if (${ckfiles} == 3) then
cat <<EOF>> $CODE/snow_ice.input
${ckfiles}  !indicates what snow/ice products are available: 0=none,1=old25km,2=new25km,3=new4km,4=bothnew
$CODE/
$DATA/
NISE_SSMISF18_${ayr}${amn}${ady}.HDFEOS
ims${yr}${dz}_4km_v1.3.asc
EOF
endif

if (${ckfiles} == 4) then
cat <<EOF>> $CODE/snow_ice.input
${ckfiles}  !indicates what snow/ice products are available: 0=none,1=old25km,2=new25km,3=new4km,4=bothnew
$CODE/
$DATA/
NISE_SSMISF18_${ayr}${amn}${ady}.HDFEOS
ims${yr}${dz}_4km_v1.3.asc
EOF
endif

if (${ckfiles} >= 2) then
 $CODE/snow_ice < $CODE/snow_ice.input
 #bzip2 -f $DATA/snow_map_4km*.hdf
else
 echo 'snow/ice data not available, product not generated'
endif

# remove original 4km and 25 km data files
echo remove 25km files for ${ayr}${amn}${ady}
if (-e $DATA/NISE_SSMISF18_${ayr}${amn}${ady}.HDFEOS) rm $DATA/NISE_SSMISF18_${ayr}${amn}${ady}.HDFEOS
echo remove current 4km files for ${yr}${dz}
if (-e $DATA/ims${yr}${dz}_4km_v1.3.asc) rm $DATA/ims${yr}${dz}_4km_v1.3.asc

#bunzip2 $DATA/snow_map_4km*.hdf.bz2

# move old file copied to .netrc_bu file back to .netrc
if (-e $HOME/.netrc_bu) mv $HOME/.netrc_bu $HOME/.netrc

exit
